HDU 2489 Minimal Ratio Tree(DFS+Kruskal最小生成树)

Minimal Ratio Tree

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 4790    Accepted Submission(s): 1535


Problem Description
For a tree, which nodes and edges are all weighted, the ratio of it is calculated according to the following equation.
这里写图片描述
Given a complete graph of n nodes with all nodes and edges weighted, your task is to find a tree, which is a sub-graph of the original graph, with m nodes and whose ratio is the smallest among all the trees of m nodes in the graph.
 

Input
Input contains multiple test cases. The first line of each test case contains two integers n (2<=n<=15) and m (2<=m<=n), which stands for the number of nodes in the graph and the number of nodes in the minimal ratio tree. Two zeros end the input. The next line contains n numbers which stand for the weight of each node. The following n lines contain a diagonally symmetrical n×n connectivity matrix with each element shows the weight of the edge connecting one node with another. Of course, the diagonal will be all 0, since there is no edge connecting a node with itself.



All the weights of both nodes and edges (except for the ones on the diagonal of the matrix) are integers and in the range of [1, 100].

The figure below illustrates the first test case in sample input. Node 1 and Node 3 form the minimal ratio tree.

 

Output
For each test case output one line contains a sequence of the m nodes which constructs the minimal ratio tree. Nodes should be arranged in ascending order. If there are several such sequences, pick the one which has the smallest node number; if there’s a tie, look at the second smallest node number, etc. Please note that the nodes are numbered from 1 .
 

Sample Input
  
  
3 2
30 20 10
0 6 2
6 0 3
2 3 0
2 2
1 1
0 2
2 0
0 0
 

Sample Output
  
  
1 3
1 2
 

Source
 

Recommend
gaojie  &nbsp|  &nbspWe have carefully selected several similar problems for you:   2491  2485  2490  2492  2488 
 

Statistic |  Submit |  Discuss | Note

题意

    有一个n个点的图, 然后给出n*n的邻接矩阵图, 要求这个图的m个结点的子图,使得这个子图所有边之和与所有点之和的商值最小。

思路

    当看到这个范围的时候,我们就很正常地想到,这题只要暴力就行了。实际上也就是暴力(233..)对于给定的n,m,我们搜出所有的方案,然后对于这些方案我们找出最小生成树,因为最小生成树可以很好地保证边之和最小。最后更新最优答案就行啦。

Code

#pragma GCC optimize(3)
#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
inline void readInt(int &x) {
    x=0;int f=1;char ch=getchar();
    while(!isdigit(ch)){if(ch=='-')f=-1;ch=getchar();}
    while(isdigit(ch))x=x*10+ch-'0',ch=getchar();
    x*=f;
}
inline void readLong(ll &x) {
    x=0;int f=1;char ch=getchar();
    while(!isdigit(ch)){if(ch=='-')f=-1;ch=getchar();}
    while(isdigit(ch))x=x*10+ch-'0',ch=getchar();
    x*=f;
}
/*================Header Template==============*/
struct Edge{
    int u,v;
    ll w;
    Edge(){}
    Edge(int a,int b,ll c):u(a),v(b),w(c){} 
}e[400];
int cnte=0,n,m,x,y,a[20],f[20],ans[20];
ll dis[20][20],z,mxl,mxr,weight[20];
inline bool cmp(Edge a,Edge b){return a.w<b.w;}
inline int find(int x){return x==f[x]?x:f[x]=find(f[x]);}
inline void getans() {
    cnte=0;
    ll nl=0,nr=0;
    for(int i=1;i<=m;i++) {
        f[a[i]]=a[i];
        nl+=weight[a[i]];
    }
    for(int i=1;i<=m;i++)
        for(int j=i+1;j<=m;j++)
            e[++cnte]=Edge(a[i],a[j],dis[a[i]][a[j]]);
    sort(e+1,e+cnte+1,cmp);
    for(int i=1,tot=1;i<=cnte&&tot<m;i++) {
        int u=find(e[i].u),v=find(e[i].v);
        if(u==v)
            continue;
        nr+=e[i].w;
        f[v]=u;
        tot++;
    }
    if(mxl==-1&&mxr==-1) {
        mxl=nr;
        mxr=nl;
        for(int i=1;i<=m;i++)
            ans[i]=a[i];
        return;
    }
    if(mxl*nl>mxr*nr) {
        mxl=nr;
        mxr=nl;
        for(int i=1;i<=m;i++)
            ans[i]=a[i];
        return;
    }
    return;
}
inline void dfs(int pos,int lst) {
    if(pos==m+1) {
        getans();
        return;
    }
    for(int i=lst;i<=n;i++) {
        a[pos]=i;
        dfs(pos+1,i+1);
    }
}
int main() {
    while(1) {
        readInt(n);
        readInt(m);
        if(!n&&!m)
            break;
        for(int i=1;i<=n;i++)
            readLong(weight[i]);
        for(int i=1;i<=n;i++)
            for(int j=1;j<=n;j++)
                readLong(dis[i][j]);
        mxl=-1;
        mxr=-1;
        dfs(1,1);
        for(int i=1;i<m;i++)
            printf("%d ",ans[i]);
        printf("%d\n",ans[m]);
    }
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值